function fls=addmf(fls_input,input_output,var_index,mf_name,mf_type,mf_par)
// ----------------------------------------------------------------------
// Add member function
// ----------------------------------------------------------------------
// This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
// Copyright (C) @YEARS@ Jaime Urzua Grez
// mailto:jaime_urzua@yahoo.com
// 
// 2011 Holger Nahrstaedt
// ----------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// ----------------------------------------------------------------------

if (argn(2)~=6) then
	error('addmf needs six parameters.');
end

if (size(mf_par,"*")~=size(mf_par,2)) then
	error("The member function parameters must be a row vector!");
end

fls=fls_input;
flsmf=tlist(['flsmf','name','type','par'],string(mf_name),string(mf_type),mf_par);

if (input_output=='input') then
	nvar=length(fls.input);
	if (var_index>nvar) then
		error('Incorrect variable index.');
	else
		fls.input(var_index).mf($+1)=flsmf;
	end

elseif (input_output=='output') then
	nvar=length(fls.output);
	if (var_index>nvar) then
		error('Incorrect variable index.');
	else
		fls.output(var_index).mf($+1)=flsmf;
	end
else
	error('Wrong input/output');
end

endfunction

