function fls=addvar(fls_input,var_type,var_name,var_range)
// ----------------------------------------------------------------------
// Add variable
// ----------------------------------------------------------------------
// This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
// Copyright (C) @YEARS@ Jaime Urzua Grez
// mailto:jaime_urzua@yahoo.com
// 
// 2011 Holger Nahrstaedt
// ----------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// ----------------------------------------------------------------------

if (argn(2)~=4) then
	error('addvar needs four parameters.');
end

if ((size(var_range,"*")~=size(var_range,2))&(size(var_range,"*")~=2)) then
	error("The range must be a row vector with 2 elements!");
end

fls=fls_input;
flsvar=tlist(['flsvar','name','range','mf'],string(var_name),var_range,list());

if (var_type=='input') then
	idx=length(fls.input);
	fls.input($+1)=flsvar;	

elseif (var_type=='output') then
	idx=length(fls.input)+length(fls.output);
	fls.output($+1)=flsvar;

else
	error('Wrong type.');
end

// ADD COLUMN IN MATRIX OF RULES IF EXIST SOME RULE AND THE SIZE WAS CORRECT

rule=fls.rule;
nrule=size(rule,1);
if nrule>0 then
	if (size(rule,2)==((length(fls.input)+length(fls.output)+1))) then
		fls.rule=[rule(:,1:idx) zeros(nrule,1) rule(:,(idx+1):$)];
	else
		warning("The fuzzy logic system have a bad table of rules!");
	end
end

endfunction
