function fls=delmf(fls_input,input_output,var_index,mf_index)
// ----------------------------------------------------------------------
// Delete member function
// ----------------------------------------------------------------------
// This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
// Copyright (C) @YEARS@ Jaime Urzua Grez
// mailto:jaime_urzua@yahoo.com
// 
// 2011 Holger Nahrstaedt
// ----------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// ----------------------------------------------------------------------

if (argn(2)~=4) then
	error('delmf needs four parameters.');
end

fls=fls_input;

if (input_output=='input') then
	nvar=length(fls.input);
	if (var_index>nvar) then
		error('Incorrect variable index.');
	end
	fls.input(var_index).mf(mf_index)=null();
	idx=nvar;	

elseif (input_output=='output') then
	nvar=length(fls.output);
	if (var_index>nvar) then
		error('Incorrect variable index.');
	end
	fls.output(var_index).mf(mf_index)=null();
	idx=length(fls.input)+nvar;	

else
	error('Wrong input/output');
end

// FIX MATRIX OF RULES IF EXIST SOME RULE AND THE SIZE WAS CORRECT

rule=fls.rule;
nrule=size(rule,1);
if nrule>0 then
	if (size(rule,2)==((length(fls.input)+length(fls.output)+2))) then
		idx1=find(abs(rule(:,idx))==idx);
		rule(idx1,idx)=0;
		idx1=find(rule(:,idx)>idx);
		rule(idx1,idx)=rule(idx1,idx)-1;
		idx1=find(rule(:,idx)<(-idx));
		rule(idx1,idx)=rule(idx1,idx)+1;
		fls.rule=rule;
	else
		warning("The fuzzy logic system have a bad table of rules!");
	end	
end

endfunction

