function fls=delvar(fls_input,var_type,var_idx)
// ----------------------------------------------------------------------
// Delete variable
// ----------------------------------------------------------------------
// This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
// Copyright (C) @YEARS@ Jaime Urzua Grez
// mailto:jaime_urzua@yahoo.com
// 
// 2011 Holger Nahrstaedt
// ----------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// ----------------------------------------------------------------------

if (argn(2)~=3) then
	error('delvar needs tree parameters.');
end

fls=fls_input;

if (var_type=='input') then
	if (var_idx>length(fls.input)) then
		error("This input no exist!.")
	end
	fls.input(var_idx)=null();
	idx=var_idx;

elseif (var_type=='output') then
	if (var_idx>length(fls.output)) then
		error("This output no exist!.")
	end
	fls.output(var_idx)=null();
	idx=length(fls.input)+var_idx;

else
	error('Wrong type.');
end

// DELETE COLUMN IN MATRIX OF RULES IF EXIST SOME RULE AND THE SIZE WAS CORRECT

rule=fls.rule;
nrule=size(rule,1);
if (nrule>0) then
	if (size(rule,2)==((length(fls.input)+length(fls.output)+3))) then
		fls.rule=[rule(:,1:(idx-1)) rule(:,(idx+1):$)];		
	else
		warning("The fuzzy logic system have a bad table of rules!");
	end
end

endfunction
