function plotvar(fls,inpout,var_number,npt)
// ----------------------------------------------------------------------
// Plot Variable Member Function
// ----------------------------------------------------------------------
// This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
// Copyright (C) @YEARS@ Jaime Urzua Grez
// mailto:jaime_urzua@yahoo.com
// 
// 2011 Holger Nahrstaedt
// ----------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// ----------------------------------------------------------------------
// CHANGES
// 2006-09-05 Small change in the behabiour. Now if only 01 var is
//            displayed, then no subplot is required.
// ----------------------------------------------------------------------
if (argn(2)<4) then
	npt=101;
end

// Plot
if (inpout=='input') then
	// INPUT variable
	npq=size(var_number,"*");
	for j=1:npq,
		if (npq>1) then
			subplot(npq,1,j);
		end
		idx=var_number(j)
		dom=fls.input(idx).range;
		X=linspace(min(dom),max(dom),npt)';
		Y=[];
		LEG='';
		REC=[min(dom) -0.1 max(dom) 1.1];
		for k=1:length(fls.input(idx).mf),			
			Y=[Y mfeval(X,fls.input(idx).mf(k).type,fls.input(idx).mf(k).par)];
			LEG=LEG+fls.input(idx).mf(k).name+'@';
		end
		plot2d(X,Y,leg=LEG,rect=REC);
		xtitle("Member functions for input number "+string(idx)+" named "+fls.input(idx).name,fls.input(idx).name,"mu("+fls.input(idx).name+")");
	end

elseif (inpout=='output') then
	// OUTPUT variable
	if (fls.type=="m") then
		npq=size(var_number,"*");
		for j=1:npq,
			if (npq>1) then
				subplot(npq,1,j);
			end
			idx=var_number(j)
			dom=fls.output(idx).range;
			X=linspace(min(dom),max(dom),npt)';
			Y=[];
			LEG='';
			REC=[min(dom) -0.1 max(dom) 1.1];
			for k=1:length(fls.output(idx).mf),			
				Y=[Y mfeval(X,fls.output(idx).mf(k).type,fls.output(idx).mf(k).par)];
				LEG=LEG+fls.output(idx).mf(k).name+'@';
			end
			plot2d(X,Y,leg=LEG,rect=REC);
			xtitle("Member functions for output number "+string(idx)+" named "+fls.output(idx).name,fls.output(idx).name,"mu("+fls.output(idx).name+")");
		end
	else
		warning("I can''t plot Takagi-Sugeno output.");
	end
else
	error('Wrong type.');
end

endfunction
